#include "Nd2MemoryTest.h"

//client reject connection after server accepts connection
//Client get ND_SUCCESS, and server get ND_CONNECTION_REFUSED in CQ

void Nd2ConnRejectCloseServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep
    Nd2TestBase::Init(v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer( x_HdrLen + x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//accept connection
	Nd2TestServerBase::CreateListen();
	Nd2TestServerBase::Listen(v4Src);
	Nd2TestServerBase::GetConnectionRequest();

	//expect connection refused, because the other side has rejected the connection
    Nd2TestServerBase::Accept(1,1,NULL,0,ND_CONNECTION_REFUSED,"Expecting ND_CONNECTION_REFUSED in CQ");

	//tear down
	Nd2TestBase::Shutdown();
}

void Nd2ConnRejectClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep    
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer(x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_READ,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge,ND_SUCCESS);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//connect
	Nd2TestClientBase::Connect(v4Src,v4Dst,1,1);

	//rejcts connection
	Nd2TestBase::Reject(NULL,0);

	//Wait 5 seconds
	Sleep(5*1000);

	//tear down
    Nd2TestBase::Shutdown();
}


void Nd2ConnCloseClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //prep
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer(x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_READ,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge,ND_SUCCESS);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//connect
	Nd2TestClientBase::Connect(v4Src,v4Dst,1,1);

	//close connector by releasing it
	HRESULT hr = m_pConnector->Release();
	LogIfErrorExit(hr,ND_SUCCESS,"Closing connector should return ND_SCUCESS",__LINE__);
	m_pConnector=NULL;
	//Wait 5 seconds
	Sleep(5*1000);
	
    
}