#include "Nd2MemoryTest.h"

//Connect to listener that is closing/has closed
//expecting ND_CONNECTION__RESUDED

void Nd2ConnectListenerClosingServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //prep
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer( x_HdrLen + x_MaxXfer+1,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//listen
	Nd2TestServerBase::CreateListen();
	Nd2TestServerBase::Listen(v4Src);

	//close listener
	m_pListen->Release();
	m_pListen = NULL;
	//wait 5 seconds
	Sleep(5*1000);

}


void Nd2ConnectListenerClosingClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer(x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge,ND_SUCCESS);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//wait 1 second
	Sleep(1000);

	//connect shoud get connection refused, because the other side has closed the listener
	Nd2TestClientBase::Connect(v4Src,v4Dst,1,1,NULL,0,ND_CONNECTION_REFUSED,"Connecting to closed/closing listener should get connection refused");
}
