#include "Nd2MemoryTest.h"
//try to connect when another connect event is in progress
//get ND_CONNECTION_ACTIVE

void Nd2DualConnectionServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep    
    Nd2TestBase::Init(v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer( x_HdrLen + x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);

	//establish connection
	Nd2TestServerBase::CreateListen();
	Nd2TestServerBase::Listen(v4Src);
	Nd2TestServerBase::GetConnectionRequest();

	//accept connection, expecting to be refused, since the peer has corrupted it
    Nd2TestServerBase::Accept(1,1,NULL,0,STATUS_CONNECTION_REFUSED,"Expecting remote peer to refuse connection");
  
}




void Nd2DualConnectionClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep
	Nd2TestBase::Init(v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer(x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_READ,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge,ND_SUCCESS);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);
	
    //do first connection
	Nd2TestClientBase::Connect(v4Src,v4Dst,1,1);

	//try another connection, should get ND_CONNECTION_ACTIVE
	HRESULT hr = m_pConnector->Bind(
        reinterpret_cast<const sockaddr*>( &v4Src ),
        sizeof(v4Src)
        );
	LogIfErrorExit(hr,STATUS_ADDRESS_ALREADY_ASSOCIATED,"Another connection is in progress, current connection should get ND_CONNECTION_ACTIVE",__LINE__);
	
	//wait 5 seconds	
	Sleep(5*1000);
}


