#include "Nd2MemoryTest.h"

//Create QP with all parameters set to maximum advertised
//shoud get no error message

void Nd2QPMaxAllServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //prep
	Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer( x_HdrLen + x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge);
	Nd2TestBase::CreateConnector();
	
    //get the max supported depth QP, and receive Sgn number
	ND2_ADAPTER_INFO adaptorInfo;
	adaptorInfo.InfoVersion=ND_VERSION_2;
	ULONG infoSize = sizeof(ND2_ADAPTER_INFO);
	HRESULT hr = m_pAdapter->Query(&adaptorInfo,&infoSize);
	LogIfErrorExit(hr,ND_SUCCESS,"Querying dataptor info failed!",__LINE__);
	queueDepth = adaptorInfo.MaxReceiveQueueDepth;
	nSge = adaptorInfo.MaxReceiveSge;

	//create queue pair, expecting success
	Nd2TestBase::CreateQueuePair(queueDepth,adaptorInfo.MaxInitiatorQueueDepth,nSge,adaptorInfo.MaxInitiatorSge);

	//tear down
	Nd2TestBase::DeregisterMemory();
}




#pragma warning( disable : 4100 )

void Nd2QPMaxAllClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //do nothing on the client
}
