#ifndef _ND2_MEMORY_TEST
#define _ND2_MEMORY_TEST

#include <ntstatus.h>
#define WIN32_NO_STATUS

#include "time.h"
#include "ndutil.h"
#include "string.h"


//default prarameters for nd2 tests
const USHORT x_DefaultPort = 54350;
const DWORD x_MaxXfer = (4 * 1024 * 1024);
const DWORD x_HdrLen = 40;
const SIZE_T x_MaxVolume = (500 * x_MaxXfer);
const DWORD x_MaxIterations = 100000;

#define ND_MR_FLAG_ALLOW_LOCAL_READ 0

//definitions for the exteded test classes
#pragma warning( disable : 25014 )

class Nd2WriteViolationServer : public Nd2TestServerBase
{
public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};


class Nd2WriteViolationClient : public Nd2TestClientBase
{
public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};



class Nd2MRDeregisterServer : public Nd2TestServerBase
{

public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );

};

class Nd2MRDeregisterClient : public Nd2TestClientBase
{

public:
    virtual void RunTest (
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
	);
};


class Nd2InvalidReadServer : public Nd2TestServerBase
{
public:
    void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2InvalidWriteServer : public Nd2TestServerBase
{
public:
    void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};


class Nd2InvalidReadWriteClient : public Nd2TestClientBase
{

public:
    void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2OverReadServer : public Nd2TestServerBase
{
public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};
class Nd2OverWriteServer : public Nd2TestServerBase{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};


class Nd2OverReadWriteClient : public Nd2TestClientBase
{

public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2LargePrivateDataServer : public Nd2TestServerBase
{

public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2LargePrivateDataClient : public Nd2TestClientBase
{

public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};


class Nd2SendReceiveNoConnectionServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2SendReceiveNoConnectionClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2SendNoReceiveServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2SendNoReceiveClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};


class Nd2ReceiveFlushQPServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2ReceiveFlushQPClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2SendReceiveConnectorClosedServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2SendReceiveConnectorClosedClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2LargeQPDepthServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2LargeQPDepthClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};
class Nd2QPMaxAllServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2QPMaxAllClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2ReadConnectionClosedServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2WriteConnectionClosedServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2ReadWriteConnectionClosedClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2MRInvalidBufferServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2MRInvalidBufferClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2ConnectListenerClosingServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2ConnectListenerClosingClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2InvalidIPServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2InvalidIPClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};
class Nd2DualListenServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2DualListenClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2DualConnectionServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2DualConnectionClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};
class Nd2ConnRejectCloseServer: public Nd2TestServerBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );
};

class Nd2ConnRejectClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  
};

class Nd2ConnCloseClient: public Nd2TestClientBase
{
	public:
    virtual void RunTest (
        _In_ const struct sockaddr_in& v4Src,
        _In_ const struct sockaddr_in& v4Dst,
        _In_ DWORD queueDepth,
        _In_ DWORD nSge
        );  

};
#endif