
$ndtestrunner = @{}
$ndtestchecker = @{}

#ndcat
$ndtestrunner["ndcat"] =
{
    if($run64)
    {
        run-ndlogotestone -testname "ndcat" -ndlogotests $env:ndlogo_testshare64 -logFileName "client-64-results.txt"
    }
    if($run32)
    {
        run-ndlogotestone -testname "ndcat" -ndlogotests $env:ndlogo_testshare32 -logFileName "client-32-results.txt"
    }
}

#ndcq
$ndtestrunner["ndcq"] =
{
    if($run64)
    {
        run-ndlogotestone -testname "ndcq" -ndlogotests $env:ndlogo_testshare64 -logFileName "client-64-results.txt"
    }
    if($run32)
    {
        run-ndlogotestone -testname "ndcq" -ndlogotests $env:ndlogo_testshare32 -logFileName "client-32-results.txt"
    }    
}
        

#ndping
$ndtestrunner["ndping"] =
{
    run-ndiotestpair -testname "ndping"
}

#ndrping
$ndtestrunner["ndrping"] =
{
    run-ndiotestpair -testname "ndrping"
}

#ndpingpong
$ndtestrunner["ndpingpong"] =
{
    run-ndiotestpair -testname "ndpingpong"
}

#ndrpingpong
$ndtestrunner["ndrpingpong"] =
{
    if($run64)
    {
        run-ndiotest -testname "ndrpingpong" -mode "poll" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64_poll" -logFileName_client "client_64_poll"
    }
    if($run32)
    {
        run-ndiotest -testname "ndrpingpong" -mode "poll" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32_poll" -logFileName_client "client_32_poll"
        run-ndiotest -testname "ndrpingpong" -mode "poll" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64_poll" -logFileName_client "client_mixed32_poll"
        run-ndiotest -testname "ndrpingpong" -mode "poll" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32_poll" -logFileName_client "client_mixed64_poll"
    }
}

#ndconn
$ndtestrunner["ndconn"] =
{
    run-ndconntestpair -testname "ndconn"
}


#ndmrrate
$ndtestrunner["ndmrrate"] =
{
    if($run64)
    {  
        run-ndmrtest -testname "ndmrrate" -ndlogotests $env:ndlogo_testshare64
    }
    if($run32)
    {
        run-ndmrtest -testname "ndmrrate" -ndlogotests $env:ndlogo_testshare32
    }
}

#ndmrlat
$ndtestrunner["ndmrlat"] =
{
    {
        run-ndmrtest -testname "ndmrlat" -ndlogotests $env:ndlogo_testshare64
    }
    if($run32)
    {
        run-ndmrtest -testname "ndmrlat" -ndlogotests $env:ndlogo_testshare32
    }
}

#ndmpic
$ndtestrunner["ndmpic"] =
{
    if($run64)
    {
        run-ndmpic -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64" -logFileName_client "client_64"# # >> $env:ndlogo_logfile
    }
    if($run32)
    {
        run-ndmpic -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32" -logFileName_client "client_32"# # >> $env:ndlogo_logfile
        run-ndmpic -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64" -logFileName_client "client_mixed32"# # >> $env:ndlogo_logfile
        run-ndmpic -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32" -logFileName_client "client_mixed64"# # >> $env:ndlogo_logfile
    }
}

#ndmw
$ndtestrunner["ndmw"] =
{
    {
        run-ndmpisim -testname "ndmw" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64" -logFileName_client "client_64"# # >> $env:ndlogo_logfile
    }
    if($run32)
    {
        run-ndmpisim -testname "ndmw" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32" -logFileName_client "client_32" # # >> $env:ndlogo_logfile
        run-ndmpisim -testname "ndmw" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64" -logFileName_client "client_mixed32"# # >> $env:ndlogo_logfile
        run-ndmpisim -testname "ndmw" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32" -logFileName_client "client_mixed64"# # >> $env:ndlogo_logfile
    }
}

#ndmval
$ndtestrunner["ndmval"] =
{
    if($run64)
    {
        run-ndmpisim -testname "ndmval" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64" -logFileName_client "client_64"# # >> $env:ndlogo_logfile
    }
    if($run32)
    {
        run-ndmpisim -testname "ndmval" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32" -logFileName_client "client_32" # # >> $env:ndlogo_logfile
        run-ndmpisim -testname "ndmval" -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64" -logFileName_client "client_mixed32"# # >> $env:ndlogo_logfile
        run-ndmpisim -testname "ndmval" -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32" -logFileName_client "client_mixed64"# # >> $env:ndlogo_logfile
    }
}

function run-nd2test( [string[]] $tests)
{
    foreach ($nd2test in $tests)
    {
        $output += log "`tRunning test: $nd2test ..."
        if($run64)
        {
            run-nd2testcase -testname $nd2test -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64" -logFileName_client "client_64"# # >> $env:ndlogo_logfile
        }
        if($run32)
        {
            run-nd2testcase -testname $nd2test -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32" -logFileName_client "client_32" # # >> $env:ndlogo_logfile
            run-nd2testcase -testname $nd2test -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64" -logFileName_client "client_mixed32"# # >> $env:ndlogo_logfile
            run-nd2testcase -testname $nd2test -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32" -logFileName_client "client_mixed64"# # >> $env:ndlogo_logfile
        }
        $result = check-ndtest -test $nd2test `
            -outdir $env:ndlogo_share\$nd2test `
            -summaryfile $env:ndlogo_share\results_summary.txt
            $output += log "`t`t$result"
    }
}
function run-ndtest( [string] $test)
{
    &$ndtestrunner[$test]
}

function check-ndtest( [string] $test, [string] $outdir, [string] $summaryfile )
{
    $passed = $TRUE; $faillines = @()

    foreach ($file in (dir $outdir))
    {
        (gc $file.FullName) | Out-Null # make sure file is up-to-date
    }
    foreach ($file in (dir $outdir))
    {
        foreach ($line in (gc $file.FullName))
        {
            if ($line -match "Line:" -or $line -match "failed")
            {
                $faillines += "`t$($file.FullName): `t$line"
                    $passed = $FALSE
            }
        }
    }

    if ($passed) { $result = "$test passed" } else { $result = "$test failed" }
    $result >> $summaryfile
        $faillines >> $summaryfile
        $result
}

function check-mpitest( [string] $test, $job, [string] $outdir, [string] $summaryfile )
{
    $passed = $TRUE ; $faillines = @();
    $job.Refresh()
    if ($job.State -ne "Finished")
    {
        $passed = $FALSE ;
        $faillines += "`t$test job $($job.id) completed in state $($job.state)"
    }
    else
    {
        foreach ($file in (dir $outdir))
        {
            (gc $file.FullName) | Out-Null # make sure file is up-to-date
        }
        foreach ($file in (dir $outdir))
        {
            foreach ($line in (gc $file.FullName))
            {
                if ($line -match "^Summary:")
                {
                    $null = $line -match "Failed=(\d+)"
                        if (([int] $matches[1]) -gt 0)
                        {
                            $faillines += "`t$($file.FullName): `t$line"
                                $passed = $FALSE
                        }
                }
            }
        }
    }
    if ($passed) { $result = "$test passed" } else { $result = "$test failed" }
    $result >> $summaryfile
        $faillines >> $summaryfile
        $result
}

function WaitFor-HpcJob( $job, [switch] $print )
{
    . {
        if (-not $job) { exit; }
        while ($job.state -ne "Finished" `
            -and $job.state -ne "Canceled" `
            -and $job.state -ne "Failed")
        {
            $job.Refresh()
                if ($print) { $job.state }
                sleep -seconds 1
        }
    } # # >> $env:ndlogo_logfile
}

function mkdir-ifneeded( [string] $path )
{
    if (-not (Test-Path $path)) { mkdir $path } else { get-item $path } # # >> $env:ndlogo_logfile
}

function run-ndtestjob(
    [string] $testname,
    [int] $numnodes,
    [string] $cmd1,
    [string] $cmd2="")
{
    $cmd1="`""+$cmd1+"`""
    $cmd2="`""+$cmd2+"`""
    $null = mkdir-ifneeded $ndlogo\$testname
    log "`t`Test $testname started" >> $env:ndlogo_logfile
    $job = New-Hpcjob -exclusive $true -name $testname -nodegroups $TestNodeGroup -numnodes $numnodes
    $jobid=$job.Id
    log "`t`Job $jobid created" >> $env:ndlogo_logfile
    while($numnodes -gt 1){
        Add-HpcTask -numnodes 1 -JobId $job.Id -command "powershell ExecutionPolicy Bypass -file $env:ndlogoscripts\test.ps1 -cmd1 $cmd1 -cmd2 $cmd2" >> $env:ndlogo_logfile
        $numnodes=$numnodes-1
    }
    Add-HpcTask -numnodes 1 -JobId $job.Id -command "powershell ExecutionPolicy Bypass -file $env:ndlogoscripts\test.ps1 -cmd1 $cmd1 -cmd2 $cmd2" >> $env:ndlogo_logfile
    Submit-hpcjob -Id $job.Id >> $env:ndlogo_logfile
    log "`t`Job $jobid submitted" >> $env:ndlogo_logfile
    WaitFor-HpcJob $job $true
    $job.Refresh()
    $jobstate=$job.state
    log  "`t`Job $jobid $jobstate" >> $env:ndlogo_logfile
    log "`t`Test $testname finished" >> $env:ndlogo_logfile

}

function run-ndlogotestone(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests,
    [string] $logFileName)
{
    $cmd="$ndlogotests\$testname.exe serverip l$ndlogo\$testname\$logFileName-client-results.txt"
    run-ndtestjob $testname 1 $cmd
    
}

function run-ndiotestpair(
    [string] $testname)
{

    if($run64)
    {
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -mode "poll" -logFileName_server "server_64_poll" -logFileName_client "client_64_poll"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -mode "block" -logFileName_server "server_64_block" -logFileName_client "client_64_block"
    }
    if($run32)
    {
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -mode "poll" -logFileName_server "server_32_poll" -logFileName_client "client_32_poll"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -mode "block" -logFileName_server "server_32_block" -logFileName_client "client_32_block"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -mode "poll" -logFileName_server "server__mixed64_poll" -logFileName_client "client__mixed32_poll"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -mode "poll" -logFileName_server "server__mixed32_poll" -logFileName_client "client__mixed64_poll"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -mode "block" -logFileName_server "server__mixed64_block" -logFileName_client "client__mixed32_block"
        run-ndiotest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -mode "block" -logFileName_server "server__mixed32_block.txt" -logFileName_client "client__mixed64_block"
    }

}

function run-ndiotest(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests_server,
    [string] $ndlogotests_client,
    [string] $mode,
    [string] $logFileName_server,
    [string] $logFileName_client)
{

    if ($mode -eq "poll") { $s = "p1" }
    else { $s = "b1" }
    $cmd1="$ndlogotests_server\$testname.exe s serverip $s l$ndlogo\$testname\$logFileName_server.txt"
    $cmd2="$ndlogotests_client\$testname.exe c serverip $s l$ndlogo\$testname\$logFileName_client.txt"
    run-ndtestjob $testname 2 $cmd1 $cmd2

}

function run-ndconntestpair(
    [string] $testname)
{
    if($run64)
    {
        run-ndconntest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_64" -logFileName_client "client_64"
    }
    if($run32)
    {
        run-ndconntest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_32" -logFileName_client "client_32"
        run-ndconntest -testname $testname -ndlogotests_server $env:ndlogo_testshare64 -ndlogotests_client $env:ndlogo_testshare32 -logFileName_server "server_mixed64" -logFileName_client "client_mixed32"
        run-ndconntest -testname $testname -ndlogotests_server $env:ndlogo_testshare32 -ndlogotests_client $env:ndlogo_testshare64 -logFileName_server "server_mixed32" -logFileName_client "client_mixed64"
    }

}

function run-ndconntest(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests_server,
    [string] $ndlogotests_client,
    [string] $logFileName_server,
    [string] $logFileName_client)
{
    $cmd1="$ndlogotests_server\$testname.exe s serverip t1 l$ndlogo\$testname\$logFileName_server.txt"
    $cmd2="$ndlogotests_client\$testname.exe c serverip t1 l$ndlogo\$testname\$logFileName_client.txt"
    run-ndtestjob $testname 2 $cmd1 $cmd2
}


function run-nd2testcase(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests_server,
    [string] $ndlogotests_client,
    [string] $logFileName_server,
    [string] $logFileName_client)
{
    $cmd1="$ndlogotests_server\nd2memorytest.exe t $testname s serverip l$ndlogo\$testname\$logFileName_server.txt"
    $cmd2="$ndlogotests_client\nd2memorytest.exe t $testname c serverip l$ndlogo\$testname\$logFileName_client.txt"
    run-ndtestjob $testname 2 $cmd1 $cmd2
}

function run-ndmrtest(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests)
{
    $cmd="$ndlogotests\$testname.exe serverip l$ndlogo\$testname\$testname-$cn-results.txt"
    run-ndtestjob $testname 1 $cmd
}



function run-ndmpisim(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests_server,
    [string] $ndlogotests_client,
    [string] $logFileName_server,
    [string] $logFileName_client)
{
    $cmd1="$ndlogotests_server\$testname.exe s serverip l$ndlogo\$testname\$logFileName_server.txt"
    $cmd2="$ndlogotests_client\$testname.exe c serverip l$ndlogo\$testname\$logFileName_client.txt"
    run-ndtestjob $testname 2 $cmd1 $cmd2
}

function run-ndmpic(
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests_server,
    [string] $ndlogotests_client,
    [string] $logFileName_server,
    [string] $logFileName_client)
{

    $cmd1="$ndlogotests_server\ndmpic.exe 1 serverip clientip l$ndlogo\ndmpic\$logFileName_server.txt"
    $cmd2="$ndlogotests_client\ndmpic.exe 0 clientip serverip l$ndlogo\ndmpic\$logFileName_client.txt"
    run-ndtestjob "ndmpic" 2 $cmd1 $cmd2

}


function new-ndmpitest(
    [string] $testname,
    [string] $ndlogo,
    [string] $ndlogotests,
    [string] $runtime = "20",
    [string] $groupname = "ComputeNodes")

{
    $job = ""
    $output = @()

    .{
        $output += mkdir-ifneeded $ndlogo\$testname
            if ($testname -eq "sendrecv1" -or $testname -eq "transpose1") { $numnodes = 2 }
            elseif ($testname -eq "accfence1" -or $testname -eq "putpscw1") { $numnodes = 4 }
            else { $numnodes = 8 }
            if ($testname -eq "mpi_bcast" -or `
            $testname -eq "coll13" -or `
            $testname -eq "scattern" ) { $corespernode = 4 }
            else { $corespernode = 1 }

            $job = New-HpcJob -Project "ND_Logo_Tests" `
                -Name "$testname" `
                -NumNodes $numnodes `
                -RunTime $runtime
                $output += $job
            if ($groupname -ne "ComputeNodes") { $output += Set-HpcJob -Job $job -NodeGroups $groupname }
                $output += Add-HpcTask -Job $job `
                    -NumNodes $numnodes `
                    -WorkDir $ndlogotests `
                    -RunTime $runtime `
                    -Stderr "$ndlogo\$testname\%CCP_JOBID%_STDERR.txt" `
                    -Stdout "$ndlogo\$testname\%CCP_JOBID%_STDOUT.txt" `
                    -CommandLine "mpiexec -cores $corespernode $ndlogotests\mpi\$testname.exe"
    }

    return $job, @($output)

}

function run-ndmpitest(
    [string] $testname,
    [string] $ndlogo = $env:ndlogo_share,
    [string] $ndlogotests,
    [string] $groupname = "ComputeNodes",
    [string] $runtime = "20")
{
    $job = ""
        $output = @()
        .{
        $job, $output = new-ndmpitest `
            -testname $testname `
            -ndlogo $ndlogo `
            -ndlogotests $ndlogotests `
            -runtime $runtime `
            -groupname $groupname

        $output += Submit-HpcJob -job $job
        $output += WaitFor-HpcJob -job $job

    }
    return $job,@($output)
}

function zip-ndresultsfolder($results)
{
    $zipheader = "PK" + [char]5 + [char]6 + ("$([char]0)" * 18)

    $zippath = $results.FullName + ".zip"
    Set-Content -Path $zippath -Value $zipheader

    $zipfile = (New-Object -ComObject shell.application).NameSpace($zippath)
    $zipfile.CopyHere($results.FullName)

    return $zippath

}